/* Encodes the input file. */
#include "stdio.h"
#include "model.h"
#include "arithcode.h"

void report_model(); /* Report back on stats collected from the model */

void report()
{
    double CR;

    fprintf( stderr, "PPM* : %ld bytes", cmpbytes );
    if (rawbytes != 0) {
	CR = (double) cmpbytes / (double) rawbytes;
	fprintf( stderr, ", %4.2f bpc, CF=%4.2f", CR*8, 1/CR );
    }
    fprintf( stderr, "\n");
    fprintf( stderr, "\n");
    /*report_model();*/
}

void encode_file(ip, fp)
FILE *ip;
FILE *fp;
{
    int cc, iplen, fplen;

    init_symbols();

    iplen = loadInput( ip, 0, preloadInput());
    fprintf( stderr, "Pre-loaded %d bytes\n", iplen );

    startInput();
    while ((cc = getInput()) >= 0) {
	encode_symbol( cc, 1 );
    }
    /*report_model();*/

    fprintf( stderr, "Loaded %d bytes\n", iplen );

    startoutputingbits();
    startencoding();

    fplen = loadInput( fp, iplen, NO_PRELOAD_LIMIT );
    rawbytes = fplen - iplen;

    while ((cc = getInput()) >= 0) {
	encode_symbol( cc, 0 );
    }
    encode_symbol( eof_symbol(), 0 );
    doneencoding();
    doneoutputingbits();
}

void main(argc,argv)
int argc;
char *argv[];
{
    FILE *fp, *fopen();

    argv++;
    if ((fp = fopen( *argv, "r" )) == NULL) {
	fprintf( stderr, "Encode: can't open %s\n", *argv );
	exit(1);
    }
    argv++;
    if (argc > 2)
	init_arguments(argc,argv,3);

    encode_file( fp, stdin );
    fclose( fp );

    report();
}
